open Eprog


let example_program_1: eprog = (
      [Val ("a", Int 5);
       Val ("b", Var "a")],
      Var "b"
)

let example_program_2: eprog = (
      [Val ("a", Int 5);
       Val ("b", Var "a")],
      BinOp (Add, Var "a", Var "b"))



(* This example shows the need for constant folding *)
let prog_08: eprog = (
      [ Val ("a", Int 5)
      ; Val ("b", Int 6)
       ],
      BinOp (Add, Var "a", Var "b"))


let asg1_task5 =
      [],
      BinOp (Sub, BinOp (Div, Int 34, Int 72), BinOp (Div, Int 17, Int 46)) 
let asg1_task4 = [],
BinOp (Mul, BinOp (Add, BinOp (Div, Int 6, BinOp (Add, Int 10, Int 49)), Int 10), 
BinOp (Add, BinOp (Sub, BinOp (Mul, Int 70, Int 77), BinOp (Div, Int 12, Int 9)), Int 5))



(* This example motivates the need for DCE *)
let prog_09: eprog = (
      [ Input "x"
      ; Val ("y", BinOp (Add, Var "x", Int 1))
      ; Val ("z", BinOp (Sub, Var "y", Var "y") )
      ]
      , Var "z"
      )

(* This example motivates the need for CSE *)
let prog_10: eprog = (
      [ Input "x"
      ; Val ("y", BinOp (Add, Var "x", Int 1))
      ; Val ("z", BinOp (Add, Int 1, Var "x") )
      ]
      , BinOp (Add, Var "z", Var "y")
      )

(* Example from the 2023 lecture *)      
let class_prog_01 : eprog = ( 
      [ 
        Input "a";
        Val ("x", 
          BinOp (Add, Var "a", Int 1));
        Val ("y",
          BinOp (Add, Int 1,  Var "a"))

      ],  
      
      BinOp(Add, Var "x", Var "y")
      )
      


      